#!/usr/bin/env python
from distutils.sysconfig import *
from inspect import *
from re import *
import os
from os.path import *
from isstring import *
from public import *

@public
def distname(object):
    """return distribution name"""
    if isstring(object): # text
        if object.find("/")>=0: # path
            path = object
            # .egg
            if path.find(".egg/")>0 or splitext(path)[1]==".egg":
                for name in path.split("/"):
                    if splitext(name)[1]==".egg":
                        matches = findall('([\w+]*)',name)
                        if matches:
                            return matches[0].replace("-","_")
            if path.find("/site-packages/")>0:
                print("test")
                sp=path.split("site-packages")[0]+"site-packages"
                pkgname = path.split("site-packages")[1].split("/")[1]
                list = os.listdir(sp)
                for basename in list:
                    dir = join(sp,basename)
                    file = join(dir,"top_level.txt")
                    if exists(file) and isfile(file):
                        top_level = open(file).read()
                        if top_level.rstrip()==pkgname:
                            matches = findall('([\w+]*)',basename)
                            if matches:
                                _distname=matches[0].replace("-","_")
                                if pkgname.lower()==_distname.lower() and pkgname!=_distname:
                                    return pkgname
                                return _distname
            else: # develop?
                stdlib = get_python_lib(standard_lib=False)
                list = os.listdir(stdlib)
                for basename in list:
                    name,ext=splitext(basename)
                    if ext==".egg-link": # distname.egg-link
                        file=join(stdlib,basename)
                        develop_path = open(file).read().splitlines()[0]
                        if path.find(develop_path)==0:
                            return name.replace("-","_")
            return
        # distname-x.y.z-py2.7.egg-info
        # distname.egg-link 
        if object.find(".egg-info")>0 or object.find(".egg-link")>0:
            matches = findall('([\w+]*)',object.split(".")[0])
            if matches:
                return matches[0].replace("-","_")
        # pkgname?
    if getmodule(object): # module
        module = getmodule(object)
        if hasattr(module,"__file__"): # file.py
            path = module.__file__
            return distname(path)
        else: # in memory module
            return module.__name__
    if ismodule(object):
        object = object.__name__
    name = str(object)
    name = name.lstrip().rstrip()
    matches = findall('([\w+]*)',os.path.basename(name))
    if matches:
        return matches[0]

if __name__=="__main__":
    import os
    print(distname(os)) # None if system module

    print(distname(__file__)) # develop
    print(distname("/Library/Python/2.7/site-packages/distname-0.3.2.RC1-py2.7.egg/pkgname/")) # distname
    print(distname("distname-1.3.0-py2.7.egg-info")) # distname
    print(distname("distname.egg-link")) # distname
    # test if distname != pkgname
    try:
        import git
        print(distname(git)) # GitPython
        print(distname(git.index)) # GitPython
        print(distname("/Library/Python/2.7/site-packages/git")) # GitPython
    except:
        print("err")
    
